[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-ID: <Z9M9gK4VS199CRKh@google.com>
Date: Thu, 13 Mar 2025 13:18:08 -0700
From: Namhyung Kim <namhyung@...nel.org>
To: Leo Yan <leo.yan@....com>
Cc: Ian Rogers <irogers@...gle.com>, Peter Zijlstra <peterz@...radead.org>,
Ingo Molnar <mingo@...hat.com>,
Arnaldo Carvalho de Melo <acme@...nel.org>,
Mark Rutland <mark.rutland@....com>,
Alexander Shishkin <alexander.shishkin@...ux.intel.com>,
Jiri Olsa <jolsa@...nel.org>,
Adrian Hunter <adrian.hunter@...el.com>,
Kan Liang <kan.liang@...ux.intel.com>,
James Clark <james.clark@...aro.org>,
Anshuman Khandual <anshuman.khandual@....com>,
linux-perf-users@...r.kernel.org, linux-kernel@...r.kernel.org,
German Gomez <german.gomez@....com>
Subject: Re: [PATCH v1] perf tests: Harden branch stack sampling test
Hello,
On Wed, Mar 12, 2025 at 10:54:50AM +0000, Leo Yan wrote:
> Hi Ian,
>
> On Tue, Mar 11, 2025 at 10:58:46PM -0700, Ian Rogers wrote:
> > On continuous testing the perf script output can be empty, or nearly
> > empty, causing tr/grep to exit and due to "set -e" the test traps and
> > fails. Add some empty file handling that sets the test to skip and
> > make grep and other text rewriting failures non-fatal by adding
> > "|| true".
> >
> > Signed-off-by: Ian Rogers <irogers@...gle.com>
> > ---
> > tools/perf/tests/shell/test_brstack.sh | 79 +++++++++++++++++++-------
> > 1 file changed, 59 insertions(+), 20 deletions(-)
> >
> > diff --git a/tools/perf/tests/shell/test_brstack.sh b/tools/perf/tests/shell/test_brstack.sh
> > index e01df7581393..6f5ae227b3e8 100755
> > --- a/tools/perf/tests/shell/test_brstack.sh
> > +++ b/tools/perf/tests/shell/test_brstack.sh
> > @@ -1,4 +1,4 @@
> > -#!/bin/sh
> > +#!/bin/bash
> > # Check branch stack sampling
> >
> > # SPDX-License-Identifier: GPL-2.0
> > @@ -17,35 +17,54 @@ fi
> >
> > skip_test_missing_symbol brstack_bench
> >
> > +set -x
> > +err=0
> > TMPDIR=$(mktemp -d /tmp/__perf_test.program.XXXXX)
> > TESTPROG="perf test -w brstack"
> >
> > cleanup() {
> > rm -rf $TMPDIR
> > + trap - EXIT TERM INT
> > }
> >
> > -trap cleanup EXIT TERM INT
> > +trap_cleanup() {
> > + set +e
> > + echo "Unexpected signal in ${FUNCNAME[1]}"
> > + cleanup
> > + exit 1
> > +}
> > +trap trap_cleanup EXIT TERM INT
> >
> > test_user_branches() {
> > echo "Testing user branch stack sampling"
> >
> > - perf record -o $TMPDIR/perf.data --branch-filter any,save_type,u -- ${TESTPROG} > /dev/null 2>&1
> > - perf script -i $TMPDIR/perf.data --fields brstacksym | tr -s ' ' '\n' > $TMPDIR/perf.script
> > + perf record -o "$TMPDIR/perf.data" --branch-filter any,save_type,u -- ${TESTPROG} > "$TMPDIR/record.txt" 2>&1
> > + perf script -i "$TMPDIR/perf.data" --fields brstacksym > "$TMPDIR/perf.script"
> >
> > # example of branch entries:
> > # brstack_foo+0x14/brstack_bar+0x40/P/-/-/0/CALL
> >
> > - set -x
> > - grep -E -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/IND_CALL/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_foo\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/CALL/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_bench\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_bar\+[^ ]*/brstack_foo\+[^ ]*/RET/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_foo\+[^ ]*/brstack_bench\+[^ ]*/RET/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack_bench\+[^ ]*/brstack_bench\+[^ ]*/COND/.*$" $TMPDIR/perf.script
> > - grep -E -m1 "^brstack\+[^ ]*/brstack\+[^ ]*/UNCOND/.*$" $TMPDIR/perf.script
> > - set +x
> > -
> > + expected=(
> > + "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/IND_CALL/.*$"
> > + "^brstack_foo\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$"
> > + "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/CALL/.*$"
> > + "^brstack_bench\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$"
> > + "^brstack_bar\+[^ ]*/brstack_foo\+[^ ]*/RET/.*$"
> > + "^brstack_foo\+[^ ]*/brstack_bench\+[^ ]*/RET/.*$"
> > + "^brstack_bench\+[^ ]*/brstack_bench\+[^ ]*/COND/.*$"
> > + "^brstack\+[^ ]*/brstack\+[^ ]*/UNCOND/.*$"
> > + )
> > + for x in "${expected[@]}"
> > + do
> > + if ! tr -s ' ' '\n' < "$TMPDIR/perf.script" | grep -E -m1 -q "$x"
> > + then
> > + echo "Branches missing $x"
> > + if [ "x$err" == "x0" ]
> > + then
> > + err=2
>
> Here it sets "err=2", as a result, if any grep command fails, the script
> exits while reporting to skip the test. This seems incorrect to me.
>
> My understanding is the regular expressions above are mandatory to be
> matched, otherwise, it must be something is wrong. We should not skip
> the test in this case.
>
> I can understand that 'perf record' cannot record all branch types, if
> this is the case, maybe we can improve the recording quality rather
> than reporting skip? E.g.,
>
> cat <<EOF > "$TMPDIR/loop.sh"
> for run in {1..5}; do perf test -w brstack; done
> EOF
>
> perf record -o "$TMPDIR/perf.data" --branch-filter any,save_type,u
> -- sh $TMPDIR/loop.sh
>
> If we run the test for 5 times, should this can allow us to ensure the
> branch samples are recorded?
The brstack (and other workload programs) can take an argument to
control its duration. For brstack, it's the number of loop iteration
and default is 999999.
Thanks,
Namhyung
Powered by blists - more mailing lists